#include "eventUnit.h"
#include "stm32f10x.h"
eventParams_ts eventParams[16];
uint16_t timerEventMask;
bool eventDriverSta;

/**
 * ڣ1ms
*/
void eventDriver(void)
{
    int i;
    
    for ( i = 0; i < 16; i++)
    {
        if (eventParams[i].countSet)
        {
        if (++ eventParams[i].count >= eventParams[i].countSet)
        {
            eventParams[i].count = 0;
            if (eventParams[i].reload == false)
            {
            eventParams[i].countSet = 0;
            }
            timerEventMask |= (1 << i);
        }
        }
    }
}
/**
 *  óʱ¼
 *  @mask¼־
 *  @reload=falseʾִֻһ
             =trueʾִУΪtimeOut_ms
    @timeOut_msʱʱ䣬ʱ
        ע
            1ִǰȹرжϣֹeventDriver()ڶʱжִгײ
 **/
void setEvent(uint16_t mask, bool reload, uint32_t timeOut_ms)
{
    __set_PRIMASK(1);
    
    eventParams[mask].countSet = timeOut_ms;
    eventParams[mask].count = 0;
    eventParams[mask].reload = reload;
    if (timeOut_ms == 0)
    {
        timerEventMask |= (1 << mask);
    }

    __set_PRIMASK(0);//ж
}
/**
 * ¼
 * @mask¼־
    ע
        1ִи¼
        2ִǰȹرжϣֹeventDriver()ڶʱжִгײ
*/
void event_post(uint16_t mask)
{
    __set_PRIMASK(1);
    eventParams[mask].countSet = 0;
    eventParams[mask].count = 0;
    eventParams[mask].reload = false;

    timerEventMask |= (1 << mask);
    __set_PRIMASK(0);//ж
}
/**
 * ¼
 * @mask¼־
    ע
        1ִǰȹرжϣֹeventDriver()ڶʱжִгײ
*/
void event_clear(uint16_t mask)
{
    __set_PRIMASK(1);
    eventParams[mask].countSet = 0;
    eventParams[mask].count = 0;
    eventParams[mask].reload = false;
    __set_PRIMASK(0);//ж
}
/**
 * ¼ȴ
    ע
        1úҪѭִУȡҪӦ¼־λ
            getEvent(...)event
        2ִǰȹرжϣֹeventDriver()ڶʱжִгײ
*/
uint16_t event_pend(void)
{
    uint16_t ret = 0;
    __set_PRIMASK(1);
    ret = timerEventMask;
    timerEventMask = 0;
    __set_PRIMASK(0);//ж
    return ret;
}
/**
 * ж¼Ƿ񴥷
 * @event¼־λ棬ɺevent_pend()
 * @maskҪжϵ¼־
*/
uint16_t getEvent(uint16_t event, uint16_t mask)
{
    return event & (1 << mask);
}



