#include "myTim.h"
#include "stm32f10x_tim.h"

TIM_CALLBACK timCallBack;

/**
 * tim3ʱʼ
 * @period_usʱʱڣ΢Ϊλ
 * @cbʱصʱʱʱøú
        ൱׳жϣ
*/
void myTim3_init(uint32_t period_us, TIM_CALLBACK cb)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE); //ʱʹ
    //жȼNVIC
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;  //TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ
        
    //ʱTIM3ʼ
    TIM_TimeBaseStructure.TIM_Period = period_us; //һ¼װԶװؼĴڵֵ  
    TIM_TimeBaseStructure.TIM_Prescaler = (72 - 1); //ϵͳʱ72MHzTIM_ClockDivision = TIM_CKD_DIV1
                                                    //˴72Ƶõ1MHzļʱӣ1MHz = 1usڣ
                                                    //Ҫ΢ڣֻͨTIM_PeriodֵȿɵõӦ
                                                    //ڶʱ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
    TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE ); //ʹָTIM3ж,ж

    TIM_Cmd(TIM3, ENABLE);  //ʹTIMx 
    timCallBack = cb;         
}
// void TIM3_IRQHandler(void)   //TIM3ж
// {
//     if (TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET)  //TIM3жϷ
//     {    
//         TIM_ClearITPendingBit(TIM3, TIM_IT_Update  );  //TIMxжϱ־ 
//         if(timCallBack)
//         {
//             timCallBack();
//         }
//     }
// }
/**
 * tim1ʱʼ
 * @period_usʱʱڣ΢Ϊλ
 * @cbʱصʱʱʱøú
        ൱׳жϣ
*/
void myTim1_init(uint32_t period_us, TIM_CALLBACK cb)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE); //ʱʹ
    //жȼNVIC
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;  //TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ
        
    //ʱTIM3ʼ
    TIM_TimeBaseStructure.TIM_Period = period_us; //һ¼װԶװؼĴڵֵ  
    TIM_TimeBaseStructure.TIM_Prescaler = (72 - 1); //ϵͳʱ72MHzTIM_ClockDivision = TIM_CKD_DIV1
                                                    //˴72Ƶõ1MHzļʱӣ1MHz = 1usڣ
                                                    //Ҫ΢ڣֻͨTIM_PeriodֵȿɵõӦ
                                                    //ڶʱ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
    TIM_ITConfig(TIM1, TIM_IT_Update, ENABLE ); //ʹָTIM3ж,ж

    TIM_Cmd(TIM1, ENABLE);  //ʹTIMx    
    timCallBack = cb;                 
}
void TIM1_UP_IRQHandler(void)   //TIM1ж
{
    if (TIM_GetITStatus(TIM1, TIM_IT_Update) != RESET)  //TIM3жϷ
    {   
        TIM_ClearITPendingBit(TIM1, TIM_IT_Update  );  //TIMxжϱ־ 
        if(timCallBack)
        {
            timCallBack();
        }
    }
}
